Pull Request or Patch supplied:Yes Resolution: fixed/implemented
Description

Basically, when doing a GetMap request, only the first GetMap response is rendered correctly.

The next ones are all rendered blank.

Unfortunately, there's no error in the logs.

Curiously, I just found out it only happens for a Postgis layer (if I export it to sqlite, everything is ok).

Tested with QGIS 2.14.6 and 2.16.2 on Debian. 

This exact project worked for QGIS 2.14.2.

I've attached a test project:

- maps.qgs has all the layer sources sqlite

- maps_postgis.qgs has the pipe layer in postgis (So you need to restore the pipe.sql into postgres and edit project file so that it points to

wherever you restored the db 

      <datasource>service='pg_qtibia' sslmode=disable key='id' srid=3844 type=LineString table="public"."pipe" (geom)

sql=</datasource>

      <keywordList>

        <value></value>

      </keywordList>

      <layername>pipes</layername>

You can test these requests in the browser after you point them to where you downloaded the test project:

- This one works good every time as it points to the sqlite only project:

http://qgisltr.demo/cgi-bin/qgis_mapserv.fcgi?map=/home/web/Desktop/qgis_server_stilying_problem/maps.qgs&&SERVICE=WM

S&VERSION=1.3.0&REQUEST=GetMap&BBOX=399813.2452616940718,450176.0919703728869,400035.4952619207324,450428.8393977318774&CRS=EPSG:3844&WIDTH=663&HEIGHT=583&LAYERS=pipes&STYLES=&FORMAT=image/png&DPI=96&MAP_RESOLUTION=96

50428.8393977318774&CRS=EPSG:3844&WIDTH=663&HEIGHT=583&LAYERS=pipes&STYLES=&FORMAT=image/png&DPI=96&MAP_RESOLUTION=96&FORMAT_OPTIONS=dpi:96


I=96&MAP_RESOLUTION=96&FORMAT_OPTIONS=dpi:96

This one points to the postgis layer project and it works good JUST FOR THE FIRST REQUEST:

http://qgisltr.demo/cgi-bin/qgis_mapserv.fcgi?map=/home/web/Desktop/qgis_server_stilying_problem/maps_postgis.qgs&&SERV

ICE=WMS&VERSION=1.3.0&REQUEST=GetMap&BBOX=399813.2452616940718,450176.0919703728869,400035.4952619207324,450428.8393977318774&CRS=EPSG:3844&WIDTH=663&HEIGHT=583&LAYERS=pipes&STYLES=&FORMAT=image/png&DPI=96&MAP_RESOLUT

207324,450428.8393977318774&CRS=EPSG:3844&WIDTH=663&HEIGHT=583&LAYERS=pipes&STYLES=&FORMAT=image/png&DPI=96&MAP_RESOLUTION=96&FORMAT_OPTIONS=dpi:96


e/png&DPI=96&MAP_RESOLUTION=96&FORMAT_OPTIONS=dpi:96
styling_problem.gif

If you drop the ELSE rule from the pipe styling you will get empty image from the second request on.

Any ideas?

History

#1 - 2016-09-02 05:09 AM - Tudor Bărăscu

I forgot to mention that at first I removed the ELSE rule from styling as I thought it was the culprit.

In absence of the ELSE rule, the image returned is blank.

#2 - 2016-09-02 10:46 AM - Tudor Bărăscu

commit:f6aad8b is the first bad commit

Thanks to Marco for pointing me to the git bisect option.

#3 - 2016-09-03 01:03 AM - Tudor Bărăscu

- File qgis_bug_test_data.zip added

I'm attaching simpler test data (project + sqlite source), please use this one.

You can replicate with the same request.

http://qgisltr.demo/cgi-bin/qgis_mapserv.fcgi?map=/home/projects/maps.qgs&&SERVICE=WMS&VERSION=1.3.0&REQUEST=GetMap&BBOX

=399813.2452616940718,450176.0919703728869,400035.4952619207324,450428.8393977318774&CRS=EPSG:3844&WIDTH=663&HEIGHT=583&LAYERS=pipes&STYLES=&FORMAT=image/png&DPI=96&MAP_RESOLUTION=96&FORMAT_OPTIONS=dpi:96


T=583&LAYERS=pipes&STYLES=&FORMAT=image/png&DPI=96&MAP_RESOLUTION=96&FORMAT_OPTIONS=dpi:96

#4 - 2016-09-05 04:11 AM - Tudor Bărăscu

More info: It seems that using a joined field column in the rule based styling filter is making qgis server rendering blank images for that specific layer. Same

goes for the labels, if they have something like CASE WHEN.. based on joined layer columns the labels will not appear.

#5 - 2016-10-06 07:38 AM - René-Luc ReLuc

Hi Tudor,

I'm investigating to fixed it.

#6 - 2016-10-07 06:59 AM - René-Luc ReLuc

- Assignee set to René-Luc ReLuc

- Target version set to Version 2.14

- Pull Request or Patch supplied changed from No to Yes
Hi Tudor,

I have probably fixed it:

    -  release-2_14 commit:e0c281e

    -  release-2_16 commit:8815f2e

    -  master_2 commit:ad32b5e

    -  master commit:1df9d7e

Can you test it ?

#7 - 2016-10-10 01:27 AM - Tudor Bărăscu

- Status changed from Open to Closed

It works as it should now. Tested under LTR, 2.16, master and master_2.

Thanks a lot René!

#8 - 2016-10-10 07:47 AM - René-Luc ReLuc

- Status changed from Closed to Reopened

I reopened it because we found a memory leak in my previous fix.

Can you test my new fix ?

    -  master commit:e34116d

    -  master_2 commit:d5328f6

    -  release-2_16 commit:f81bce2

    -  release-2_14 commit:ca0fb19

Thanks

#9 - 2016-10-11 07:24 AM - Tudor Bărăscu

Tested on all branches and it works.

I'll let you close the issue.

Thanks a lot for your very nice work.

#10 - 2016-10-12 08:13 AM - René-Luc ReLuc

- Status changed from Reopened to Closed

- Resolution set to fixed/implemented

Last commits:

    -  master commit:726bac5

    -  master_2 commit:21cfb7d

    -  release-2_16 commit:3906059

    -  release-2_14 commit:614acd0

#11 - 2016-10-13 08:37 AM - Tudor Bărăscu
@Rene-Luc Although testing with the provided test data works good, my production project has problems.

I can replicate with a GetMap request and there's a pattern in that the first request works, the second doesn't, the third works, 4th not etc.

commit:21cfb7d introduced this as with the previous commit all is working fine.

Is this helpful? I'll try and narrow it down further.

Thanks a lot!

#12 - 2016-10-13 08:43 AM - René-Luc ReLuc

Hi Tudor,

Can I reproduced the problem with the data you provided ?

    -  qgis_server_stilying_problem.zip

    -  qgis_bug_test_data.zip

#13 - 2016-10-13 11:03 AM - Tudor Bărăscu

Nope, that's just the thing, I didn't catch it with the test data.

I will try to isolate it tomorrow.

Thanks Rene!

It seems it's more to be a false positive.

The problem seems to be localized on my production server but on the GetProjectSettings request which throws Internal Server Error.

I've moved the project on my laptop and the request works without crashing although both servers are built from source and it's the same system.

Still, the fact that it's working if I rebuild the server with an earlier commit leads me to believe there's a catch/bug somewhere.

#14 - 2016-10-15 07:50 AM - Tudor Bărăscu

@Rene

I just figured out why the server is crashing when doing a GetProjectSettings request.

The server cannot access one Postgis layer (detail: different user when connecting to the database to ensure some sensitive data doesn't get out - I also

have exclude layers setup). Up until commit:21cfb7d the server simply discarded the layers that it couldn't connect to but now it crashes when doing the

GetProjectSettings request.

This specific layer is involved in a 1-n Relation as a Referenced layer (child).

As soon as I gave SELECT privileges on that layer.. the problem is gone!

IMHO the server shouldn't crash in this situation but simply discard layers that it cannot access.

#15 - 2016-10-15 10:29 AM - Tudor Bărăscu

You can replicate the problem by deleting the vl_material.. table from the offline.sqlite and restarting the apache server so that the cache is dropped.
Then do a 

http://qgisltr.demo/cgi-bin/qgis_mapserv.fcgi?map=/home/projects/maps.qgs&#38;&#38;SERVICE=WMS&#38;VERSION=1.3.0&#38;REQUEST=GetPr

jectSettings

#16 - 2016-10-17 01:50 AM - Tudor Bărăscu

@Rene

There is also a performance penalty regression. My production server seemed to be behaving less responsive and I timed a GetMap request on a more

busy area:

Latest commit in release_2.14:     4.023 seconds

Before problems commit: 1.211 seconds  (commit d708473d5d9ab8e0ad55a7113d7bf9d94a087b2f)

So, almost 4 times slower..on the same GetMap request.

I have 2 or 3 joined layers that are used in styling.

#17 - 2016-10-17 02:04 AM - René-Luc ReLuc

Hi Tudor,

Thanks for founding issues, is the GetProjectSettings Request the only one to segfault QGIS Server ?

I apologized, but I never used this request.

About the time performance penalty, I think it's normal. Before my fix, no joins were used. So that mean that QGIS Server never get features in the joined

layer to made the draw. With the bugfix, QGIS Server will used the 2 or 3 joined layers to render.

It will probably have some point to enhance the way QGIS (not only QGIS Server) uses joined layer.

#18 - 2016-10-17 03:21 AM - Tudor Bărăscu

cHello again,

Yes, only the GetProjectSettings is buggy (when layers are missing), everything else seems to be ok.

The GetProjectSettings request is used by the QGIS Web Client (otherwise I wouldn't have noticed it).

The commit:d708473d5d9ab8e0ad55a7113d7bf9d94a087b2f is right before (or two commits before) the commit that started this issue

(commit:f6aad8bad6db72d0b1e573998ac7dcb2405dce55).

So, in both tests the joined layers are used in the styling and the GetMap returned images are identical, which would be perfect if the performance penalty

wouldn't have emerged.

#19 - 2016-10-25 05:08 AM - René-Luc ReLuc

Hi Tudor,

Can you test my last commit on qgis-server ? I probably fixed your issue with getProjectSettings.
Regards,

#20 - 2016-10-26 01:54 AM - Tudor Bărăscu

Hi Rene,

Indeed the problem has dissapeared.

I tested after and before your commit on the 2_14 branch.

Thanks a lot!

Regarding the performance hit, it's still present.

On the release-2_14 branch, the difference between commit:d708473d5d9ab8e0ad55a7113d7bf9d94a087b2f (from june 13) and the latest commit is

quite large. By huge I mean almost four times higher for a getmap request.

0.9 seconds versus 3.6 seconds.

Keep in mind that that everything works as it should from the user perspective (the joined layers work in both tests).

Files

styling_problem.gif 217 KB 2016-09-02 Tudor Bărăscu

qgis_server_stilying_problem.zip 1.58 MB 2016-09-02 Tudor Bărăscu

qgis_bug_test_data.zip 1.54 MB 2016-09-02 Tudor Bărăscu
